#by TIG
module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_ExtrudeAlongPath = UI::Command.new('挤压矩形') { ExtrudeAlongPath.main }
		cmd_ExtrudeAlongPath.large_icon = 'Images/ExtrudeAlongPath_24.png'
		cmd_ExtrudeAlongPath.small_icon = 'Images/ExtrudeAlongPath_16.png'
		cmd_ExtrudeAlongPath.status_bar_text = '沿路径挤压矩形。'
		cmd_ExtrudeAlongPath.tooltip = '沿路径挤压矩形'

		# Menu
		@menu.add_item( cmd_ExtrudeAlongPath )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_item( cmd_ExtrudeAlongPath )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class ExtrudeAlongPath
		def self.main

		@error=0 ### 17/8/5 ###
		model = Sketchup.active_model
			
		begin
			model.start_operation("沿路径挤压矩形", true)
		rescue
			model.start_operation("沿路径挤压矩形")
		end

		entities = model.active_entities
		ss = model.selection

		if ss.empty?
		  UI.messagebox("未选择路径 !")
		  return nil
		end
		### #################################################################

		def self.get_vertices

		### this next bit is mainly thanks to Rick Wilson's weld.rb ###

			model=Sketchup.active_model
			ents=model.active_entities
			@sel=model.selection
			sl=@sel.length
			verts=[]
			edges=[]
			@newVerts=[]
			startEdge=startVert=nil

		#DELETE NON-EDGES, GET THE VERTICES

			@sel.each {|item| edges.push(item) if item.typename=="Edge"}
			edges.each {|edge| verts.push(edge.vertices)}
			verts.flatten!

		#FIND AN END VERTEX

			vertsShort=[]
			vertsLong=[]
			vertsEnds=[] ### 17/8/5 ### to ensure array is only ends ###
			verts.each do |v|
				if vertsLong.include?(v)
					vertsShort.push(v)
				else
					vertsLong.push(v)
				end
			end
			vertsLong.each do |v| ### 17/8/5 ### to ensure array is only ends ###
				if not vertsShort.include?(v)
					vertsEnds.push(v)
				end
			end ### 17/8/5 ### to ensure array is only ends ###
			if vertsEnds.length==0 ### i.e. it's looped ###
				### path start or end ? ### 17/8/5 ###
				if @theEnd==0
				  startVert=vertsLong.first
				  startEdge=startVert.edges.first
				else
				  startVert=vertsLong.last
				  startEdge=startVert.edges.first
				end
				###
				closed=true
			else
				if vertsEnds.length != 2
					UI.messagebox("所选路径有分叉或不连续 ! \n无法进行挤压 ! \n请重新选择单个连续路径... ") ### 17/8/5 ###
					@error=1
					return nil
				else
					### path start or end ? ### 17/8/5 ###
					if @theEnd==0
					  startVert=vertsEnds.first
					else
					  startVert=vertsEnds.last
					end
					###
					closed=false
					startEdge=startVert.edges.first
				end
			end
			@sel.clear


		#SORT VERTICES, LIMITING TO THOSE IN THE SELECTION SET

			if startVert==startEdge.start
				@newVerts=[startVert]
				counter=0
				while @newVerts.length < verts.length
					edges.each do |edge|
						if edge.end==@newVerts.last
							@newVerts.push(edge.start)
						elsif edge.start==@newVerts.last
							@newVerts.push(edge.end)
						end
					end
					counter+=1
					if counter > verts.length
						return nil if UI.messagebox("似乎出问题了，是否重试 ?", MB_YESNO)!=6
						@newVerts.reverse!
						reversed=true
					end
				end
			else
				@newVerts=[startVert]
				counter=0
				while @newVerts.length < verts.length
					edges.each do |edge|
						if edge.end==@newVerts.last
							@newVerts.push(edge.start)
						elsif edge.start==@newVerts.last
							@newVerts.push(edge.end)
						end
					end
					counter+=1
					if counter > verts.length
						return nil if UI.messagebox("似乎出问题了，是否重试 ?", MB_YESNO)!=6
						@newVerts.reverse!
						reversed=true
					end
				end
			end
			@newVerts.reverse! if reversed

		#CONVERT VERTICES TO POINT3Ds

			@newVerts.collect!{|x| x.position}

		### now have an array of vertices in order with NO forced closed loop ...

		end ### get_vertices

		### near or far ?
		@theEnd=0
		get_vertices
		if @error==1
		  return nil
		end

		### dialog #################################################################

		alignments = ["边缘","中心(底部)","中心","中心(侧边)"]
		enums = [alignments.join("|")]
		prompts = ["对齐: ","宽度: ","高度: "]

		if not @widthIn
		   values = ["中心(底部)",50.mm,50.mm]
		else
		   values = [@alignment,@widthIn,@heightInfirst]
		end

		results = inputbox prompts, values, enums, "参数设置"

		return nil if not results ### i.e. the user cancelled the operation

		@alignment,@widthIn,@heightInfirst = results

		@heightIn = @heightInfirst

		### #################################################################

		### #################################################################

		### restore selection set of edges and display them
		def self.edge_reselector (xnewVerts)
		 model = Sketchup.active_model
		 ents=model.active_entities
		 theEdgeX = []
		 0.upto(xnewVerts.length-2) do |i| ### 1/8/5
		   theEdgeX[i] = ents.add_line(xnewVerts[i],xnewVerts[i+1])  ### make vertices into edges
		 end
		 model.selection.clear
		 model.selection.add theEdgeX
		end
		###def


		### do main stuff #################################################################

		pt1 = @newVerts[0]
		pt2 = @newVerts[1]

		width = @widthIn
		if @widthIn == 0.mm ### can't be 0 ###
		   @widthIn = 100.mm
		   edge_reselector(@newVerts)
		   UI.messagebox("宽度不能为 0 !")
		   return nil
		end
		###
		if @heightIn == 0.mm ### can't be 0 ###
		   @heightIn = @widthIn
		end
		###
		if (pt1.x == pt2.x) and (pt1.y == pt2.y) ### vertical 1st path ###
		   vflag = 1
		   height = @heightIn
		else
		   vflag = 0
		   height = ((@heightIn * (pt1.distance pt2)) / (pt1.distance [pt2.x,pt2.y,pt1.z]))
		end
		###
		if @alignment == "边缘"
		   offL = width
		   offR = 0
		   heightUp = height
		   heightDn = 0
		   cpatt = "__" ### 17/8/5 ###
		end
		if @alignment == "中心(底部)"
		   offL = width / 2
		   offR = width / 2
		   heightUp = height
		   heightDn = 0
		   cpatt = "." ### 17/8/5 ###
		end
		if @alignment == "中心(侧边)"
		   offL = width
		   offR = 0
		   heightUp = height / 2
		   heightDn = height / 2
		   cpatt = "_" ### 17/8/5 ###
		end
		if @alignment == "中心"
		   offL = width / 2
		   offR = width / 2
		   heightUp = height / 2
		   heightDn = height / 2
		   cpatt = "-.-" ### 17/8/5 ###
		end
		### #################################################################

		if vflag == 1 ### vertical ### 7/8/5
		  vec = pt1.vector_to [(pt1.x + 1), pt1.y, pt1.z]
		else
		  vec = pt1.vector_to [pt2.x, pt2.y, pt1.z]
		end

		### #################################################################

		piBy2 = 1.5707963267948965 ### a radian right-angle for calculating vector offset to edges

		rotated_vecL = vec.transform(Geom::Transformation.rotation(pt1, [0,0,1], (0 + piBy2))) ### 7/8/5
		pt1_leftC = pt1.offset(rotated_vecL, offL)
		rotated_vecR = vec.transform(Geom::Transformation.rotation(pt1, [0,0,1], (0 - piBy2))) ### 7/8/5
		pt1_rightC = pt1.offset(rotated_vecR, offR)

		if vflag == 1 ### 1st path is vertical ### 7/8/5
		  pt1_left  = pt1_leftC.offset([-1,0,0], heightDn)
		  pt1_right = pt1_rightC.offset([-1,0,0], heightDn)
		  pt2_left  = pt1_leftC.offset([1,0,0], heightUp)
		  pt2_right = pt1_rightC.offset([1,0,0], heightUp)
		else
		  pt1_left  = pt1_leftC.offset([0,0,-1], heightDn)
		  pt1_right = pt1_rightC.offset([0,0,-1], heightDn)
		  pt2_left  = pt1_leftC.offset([0,0,1], heightUp)
		  pt2_right = pt1_rightC.offset([0,0,1], heightUp)
		end

		###

		ents=entities

		### #################################################################
		### add construction line along first vector ### 7/8/5
		cline1 = ents.add_cline(pt1,pt2)
		cline1.end=nil
		cline1.start=nil
		cline1.stipple=cpatt ### 17/8/5 ###


		### group the extrusion... ### 7/8/5 #################################################################

		group=entities.add_group
		entities=group.entities

		theFace = entities.add_face(pt1_right, pt1_left, pt2_left, pt2_right) ### 7/8/5

		if vflag == 1 and height > 0
		   theFace.reverse!
		end
		if vflag == 1 and width < 0
		   theFace.reverse!
		end
		if vflag == 1 and pt1.z > pt2.z
		   theFace.reverse!
		end

		### check start /end of path ###
		keypress = 6 ### = YES
		### ask if face starts at correct side ? ### 17/8/5 ###
		model.selection.clear
		model.selection.add [theFace]
		model.selection.add [theFace.edges]
		###
		if @alignment == "中心" || @alignment == "中心(底部)"
			keypress = 6
		else
			keypress = UI.messagebox("从这端开始 ?", MB_YESNO) ###
		end
		if keypress != 6
		  ### get rid of old stuff first ###
		  entities.erase_entities cline1
		  entities.erase_entities model.selection
		  edge_reselector(@newVerts)
		  @theEnd=1
		  get_vertices
		  ###
		  pt1 = @newVerts[0]
		  pt2 = @newVerts[1]
		  if (pt1.x == pt2.x) and (pt1.y == pt2.y) ### vertical 1st path ###
			 vflag = 1
			 height = @heightIn
		  else
			 vflag = 0
			 height = ((@heightIn * (pt1.distance pt2)) / (pt1.distance [pt2.x,pt2.y,pt1.z]))
		  end
		  if vflag == 1 ### vertical ### 7/8/5
			vec = pt1.vector_to [(pt1.x + 1), pt1.y, pt1.z]
		  else
			vec = pt1.vector_to [pt2.x, pt2.y, pt1.z]
		  end
		  rotated_vecL = vec.transform(Geom::Transformation.rotation(pt1, [0,0,1], (0 + piBy2))) ### 7/8/5
		  pt1_leftC = pt1.offset(rotated_vecL, offL)
		  rotated_vecR = vec.transform(Geom::Transformation.rotation(pt1, [0,0,1], (0 - piBy2))) ### 7/8/5
		  pt1_rightC = pt1.offset(rotated_vecR, offR)
		  if vflag == 1 ### 1st path is vertical ### 7/8/5
			pt1_left  = pt1_leftC.offset([-1,0,0], heightDn)
			pt1_right = pt1_rightC.offset([-1,0,0], heightDn)
			pt2_left  = pt1_leftC.offset([1,0,0], heightUp)
			pt2_right = pt1_rightC.offset([1,0,0], heightUp)
		  else
			pt1_left  = pt1_leftC.offset([0,0,-1], heightDn)
			pt1_right = pt1_rightC.offset([0,0,-1], heightDn)
			pt2_left  = pt1_leftC.offset([0,0,1], heightUp)
			pt2_right = pt1_rightC.offset([0,0,1], heightUp)
		  end
		  ### add NEW construction line along NEW first vector ### 17/8/5
		  cline1 = ents.add_cline(pt1,pt2)
		  cline1.end=nil
		  cline1.start=nil
		  cline1.stipple=cpatt
		  ###
		  theFace = entities.add_face(pt1_right, pt1_left, pt2_left, pt2_right) ###
		if vflag == 1 and height > 0
		   theFace.reverse!
		end
		if vflag == 1 and width < 0
		   theFace.reverse!
		end
		if vflag == 1 and pt1.z > pt2.z
		   theFace.reverse!
		end

		end
		### end sorting start / end of path ### 17/8/5 ###


		###
		### ask if face starts at correct side ? ### 7/8/5
		if @alignment == "边缘" or  @alignment == "中心(侧边)"
		  model.selection.clear
		  model.selection.add [theFace]
		  model.selection.add [theFace.edges]
		end

		### if NO then reverse face side ### 7/8/5

		### #################################################################

		@@theEdges= []
		  0.upto(@newVerts.length-2) do |i| ### 1/8/5
		  @@theEdges[i] = ents.add_line(@newVerts[i],@newVerts[i+1]) ### make vertices into edges
		end

		### follow me along selected edges

		if height > 0
		  if width > 0
			theExtrusion=theFace.reverse!.followme @@theEdges ###
		  end
		  if width < 0
			theExtrusion=theFace.followme @@theEdges ###
		  end
		end
		if height < 0
		  if width > 0
			theExtrusion=theFace.followme @@theEdges ###
		  end
		  if width < 0
			theExtrusion=theFace.reverse!.followme @@theEdges ###
		  end
		end

		###
		if not theExtrusion
		  UI.messagebox("无法挤压 ! \n所选路径可能有分叉 ! \n请重新选择单个连续路径... ")
		  entities.erase_entities theFace.edges
		  entities.erase_entities cline1
		  edge_reselector(@newVerts)
		  return nil
		end
		###
		entities.erase_entities cline1
		model.commit_operation

		### #################################################################
		### restore selection set of edges and display them
		edge_reselector(@newVerts)


		end ### end def
	end

end # module