=begin rdoc
作者：dota_
版本：1.0
名称：滑动隐藏
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Hideedge = UI::Command.new('滑动隐藏') { Sketchup.active_model.select_tool Hideedge.new }
		cmd_Hideedge.large_icon = 'Images/Hideedge_24.png'
		cmd_Hideedge.small_icon = 'Images/Hideedge_16.png'
		cmd_Hideedge.status_bar_text = '按住鼠标左键启用，隐藏鼠标滑过的边线。'
		cmd_Hideedge.tooltip = '滑动隐藏'

		# Menu
		@menu.add_item( cmd_Hideedge )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_item( cmd_Hideedge )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Hideedge

	def initialize
		@ip = Sketchup::InputPoint.new
		@cursor = 645 #erase
		@buttondown = false
	end

	def reset
		@ip.clear
		Sketchup.set_status_text "按住鼠标左键启用，隐藏鼠标滑过的边线。"
	end

	def activate
		self.reset
	end

	def onMouseMove(flags, x, y, view)
		@ip.pick(view,x,y)
		if (@buttondown)
			if (@ip.edge)
				hide_edge (@ip.edge)
				
			end
		end
	end

	def onSetCursor
		UI.set_cursor(@cursor)
	end

	def onLButtonDown(flags, x, y, view)
		@buttondown = true
		@ip.pick(view,x,y)
		if (@ip.edge)
			hide_edge (@ip.edge)
			puts "隐藏了一段边线"
		end
	end

	def onLButtonUp(flags, x, y, view)
		@buttondown = false
	end

	def hide_edge (edge)
		Sketchup.active_model.start_operation '滑动隐藏'
		if (edge.curve)
			edge.curve.each_edge {|e| e.hidden = true}
			puts "隐藏了一段曲线"
		else
			edge.hidden = true
			puts "隐藏了一段边线"
		end
		Sketchup.active_model.commit_operation 
	end

	end
  
end # module