#-----------------------------------------------------------------------------
# Name        :   change to current layer
# Author      :   zdarc@163.com
# Description :   A script to change to current layer
# Date        :   06/24/2005
#-----------------------------------------------------------------------------

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Show_all = UI::Command.new('显示图层') { Layers.show_all }
		cmd_Show_all.large_icon = 'Images/Show_all_24.png'
		cmd_Show_all.small_icon = 'Images/Show_all_16.png'
		cmd_Show_all.status_bar_text = '显示所有图层。'
		cmd_Show_all.tooltip = '显示图层'
		
		cmd_Hide_all = UI::Command.new('隐藏图层') { Layers.hide_all }
		cmd_Hide_all.large_icon = 'Images/Hide_all_24.png'
		cmd_Hide_all.small_icon = 'Images/Hide_all_16.png'
		cmd_Hide_all.status_bar_text = '隐藏所有图层。'
		cmd_Hide_all.tooltip = '隐藏图层'

		# Menu
		@menu.add_separator
		@menu.add_item( cmd_Show_all )
		@menu.add_item( cmd_Hide_all )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_separator
		@toolbar.add_item( cmd_Show_all )
		@toolbar.add_item( cmd_Hide_all )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Layers

		def self.show_all
			ss = Sketchup.active_model

			for layer in ss.layers
				if not layer.visible?
			layer.visible = true
				end
			end
		end

		#########################################
		def self.hide_all
			ss = Sketchup.active_model
			layer_activa = ss.active_layer

			for layer in ss.layers
				if layer.visible? and layer.name != layer_activa.name
			layer.visible = false
				end
			end
		end

	end
  
end # module