=begin rdoc
作者：dota_
版本：1.0
名称：建立方体
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Makebox = UI::Command.new('建立实体') { Sketchup.active_model.select_tool Makebox.new }
		cmd_Makebox.large_icon = 'Images/Makebox_24.png'
		cmd_Makebox.small_icon = 'Images/Makebox_16.png'
		cmd_Makebox.status_bar_text = '点击创建实体。'
		cmd_Makebox.tooltip = '建立实体'

		# Menu
		@menu.add_item( cmd_Makebox )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_item( cmd_Makebox )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Makebox

		def activate
			@ip = Sketchup::InputPoint.new
			@iptemp = Sketchup::InputPoint.new
			@displayed = false
			@sp = []
		end

		def onMouseMove(flags, x, y, view)
			pos = @ip.position
			Sketchup.set_status_text('点击创建实体。')
			@iptemp.pick view, x, y
			if( @iptemp.valid? )
				changed = @iptemp != @ip
				@ip.copy! @iptemp
				pos = @ip.position;           
				if( changed and (@ip.display? or @displayed) )
					view.invalidate
				end
			end
		end

		def make_box (width, length, height)
			model = Sketchup.active_model
			entities = model.active_entities
			model.start_operation "建立实体"

			pts = []
			pts[0] = [0, 0, 0]
			pts[1] = [width, 0, 0]
			pts[2] = [width, length, 0]
			pts[3] = [0, length, 0]

			frame = entities.add_group
			frame.move!(Geom::Transformation.new(Geom::Point3d.new @sp.x, @sp.y, @sp.z))
			face = frame.entities.add_face pts
			frame.to_component
			face.pushpull -height, true
			face.reverse!
			
			model.commit_operation
		end

		def onLButtonUp(flags, x, y, view)
			@sp = @ip.position
			prompts = ["长度", "宽度", "高度"]
			values = [50.mm, 50.mm, 1000.mm]
			results = inputbox prompts, values, "建立实体"
			make_box results[0], results[1], results[2] if results
			Sketchup.send_action('selectSelectionTool:')
		end

		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw view
				@displayed = true
			else
				@displayed = false
			end
		end

	end
  
end # module