=begin rdoc
作者：dota_
版本：1.0
名称：赋面材质
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Materials = UI::Command.new('赋面材质') { Sketchup.active_model.select_tool Materials.new }
		cmd_Materials.large_icon = 'Images/Materials_24.png'
		cmd_Materials.small_icon = 'Images/Materials_16.png'
		cmd_Materials.status_bar_text = '选择在模型中的材质，执行本插件，点击鼠标左键对面赋材质，无视群组。'
		cmd_Materials.tooltip = '赋面材质'

		# Menu
		@menu.add_item( cmd_Materials )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_item( cmd_Materials )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Materials 
	
		def initialize
			@ip = Sketchup::InputPoint.new
			@alt = false
		end

		def reset
		  @ip.clear
		  Sketchup::set_status_text "点击鼠标左键对面赋材质(双面)，无视群组，按住ALT获取材质。"
		end

		def onSetCursor
			if @alt
				UI.set_cursor( 651 )
			else
				UI.set_cursor( 681 )
			end
		end

		def activate
		  self.reset
		end

		def onMouseMove(flags, x, y, view)
		  @ip.pick(view,x,y)
		  view.tooltip = @ip.tooltip
		end
		
		def onKeyDown(key, repeat, flags, view)
			if key == VK_ALT
				@alt = true
				onSetCursor
			end
		end
		
		def onKeyUp(key, repeat, flags, view)
			if key == VK_ALT
				@alt = false
				onSetCursor
			end
		end
	
		def onLButtonDown(flags, x, y, view)
			@ip.pick(view,x,y)
			model = Sketchup.active_model
			if @alt
				if (@ip.face)
					camera = model.active_view.camera
					eye = camera.eye
					tar = camera.target
					vec = eye.vector_to(tar)
					if vec.angle_between(@ip.face.normal) <= 90.degrees
						Sketchup.active_model.materials.current = @ip.face.back_material
					else
						Sketchup.active_model.materials.current = @ip.face.material
					end
				end
			else
				if model.materials.current
					name = model.materials.current.name 
				else
					name = nil
				end
				if (@ip.face)
					if name == nil
						model.start_operation "赋面材质"
						@ip.face.material = name
						@ip.face.back_material = name
						model.commit_operation
					else
						if (model.materials[ name ])
							model.start_operation "赋面材质"
							@ip.face.material = name
							@ip.face.back_material = name
							model.commit_operation
						end
					end
				end
			end
		end
	end

end # module