###---------------------------------------------------------------------
#	  Name: PurgeAll.rb
#   Description: Plugins > Purge...
#   Author: TIG (c) 20070225
#   Usage: Pick "Purge...", or use a Shortcut Key to it.
#           It Purges all unused Components, Layers, Materials, Styles.
#           Choose which type(s) to purge from the dialog (Yes/No).
#           It only works in v6+.
#		Type: Tool
#   Version: 1.0	 2070225	First issue.
#            1.1   20070225 v.6000277 alowed !
#            1.2   20070226 A 4 options dialog added, now Menu= Purge...
#            1.3   20070226 'Make Report' option added.
###---------------------------------------------------------------------

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_PurgeAll = UI::Command.new('清理场景') {
		PurgeAll.do
		}
		cmd_PurgeAll.large_icon = 'Images/PurgeAll_24.png'
		cmd_PurgeAll.small_icon = 'Images/PurgeAll_16.png'
		cmd_PurgeAll.status_bar_text = '清理未使用组件、图层、材质及风格.'
		cmd_PurgeAll.tooltip = '清理场景'

		# Menu
		@menu.add_item( cmd_PurgeAll )

		# Toolbar
		@toolbar.add_item( cmd_PurgeAll )
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class PurgeAll ### v1.3
		def PurgeAll::do
		  ### show VCB and status info
		  Sketchup::set_status_text(("清理中...清理完毕后会显示统计，请耐心等待..." ),SB_PROMPT)
		  Sketchup::set_status_text("",SB_VCB_LABEL)
		  Sketchup::set_status_text("",SB_VCB_VALUE)
		  ###
		  if Sketchup.version_number < 6000277###v1.1
			UI.messagebox("抱歉，仅支持sketchup6及以上版本. ")
			return nil
		  end#if
		  ### ###v1.2
		  model=Sketchup.active_model
		  entities=model.entities
		  definitions=model.definitions
		  layers=model.layers
		  materials=model.materials
		  styles=model.styles
		  model.start_operation "清理场景"
		  t = Time.now #获取当前时间
		  ###

			compos1=definitions.count
			definitions.purge_unused
			co=compos1-definitions.count
			cmsg="\n组件:\t "+co.to_s

			layers1=layers.count
			layers.purge_unused
			la=layers1-layers.count
			lmsg="\n图层:\t "+la.to_s


			materials1=materials.count
			materials.purge_unused
			ma=materials1-materials.count
			mmsg="\n材质:\t "+ma.to_s

			styles1=styles.count
			styles.purge_unused
			st=styles1-styles.count
			smsg="\n风格:\t "+st.to_s+"\n"

		  ### report v1.3

			UI.messagebox("清理统计:\n"+cmsg+lmsg+mmsg+smsg+"\n用时:\t #{Time.now-t} 秒\t\t")

		  ###
		  model.commit_operation###for undo
		end #def
	end #class
  
end # module