=begin rdoc
作者：dota_
版本：1.0
名称：保存为SU8
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )
		if Sketchup.version.to_i >= 14
			cmd_Save = UI::Command.new('保存为SU8') { Save.main }
			cmd_Save.large_icon = 'Images/Save_24.png'
			cmd_Save.small_icon = 'Images/Save_16.png'
			cmd_Save.status_bar_text = '保存为SU8版本的文件。'
			cmd_Save.tooltip = '保存为SU8'

			# Menu
			@menu.add_item( cmd_Save )
			#@menu.add_separator

			# Toolbar
			@toolbar.add_item( cmd_Save )
			#@toolbar.add_separator
		end
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Save
		def self.main
			model = Sketchup.active_model
			path = model.path
			if path == ''
				UI.messagebox '请先保存模型 !'
				return
			end
			r = model.save path, Sketchup::Model::VERSION_8
			if r == false
				UI.messagebox '保存失败!'
			end
		end
	end
  
end # module