=begin rdoc
作者：dota_
版本：1.0
名称：智能梯步拉伸
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Smart_Pushpull = UI::Command.new('智能梯步拉伸') { Sketchup.active_model.tools.push_tool Smart_Pushpull.new }
		cmd_Smart_Pushpull.large_icon = 'Images/Smart_Pushpull_24.png'
		cmd_Smart_Pushpull.small_icon = 'Images/Smart_Pushpull_16.png'
		cmd_Smart_Pushpull.status_bar_text = '智能梯步拉伸，按住鼠标启用。'
		cmd_Smart_Pushpull.tooltip = '智能梯步拉伸'

		# Menu
		@menu.add_item( cmd_Smart_Pushpull )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_item( cmd_Smart_Pushpull )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
class Smart_Pushpull 

	def initialize
		@ip = Sketchup::InputPoint.new
		@step = 0
		@buttondown = false
		@faces = []
		Sketchup.active_model.selection.clear
		@steps = []
	end

	def reset
		@ip.clear
		Sketchup::set_status_text "智能梯步拉伸，按住鼠标启用。梯级 #{@step}, 当前高度 #{@hight.to_m} 米"
	end

	def activate
		@hight = 150.mm
		Sketchup::set_status_text "递增值: #{@hight} ", SB_VCB_LABEL
		self.reset
	end

	def onMouseMove(flags, x, y, view)
		if @buttondown
			@ip.pick(view,x,y)
			face = @ip.face
			if face!=nil
				if not facenil face
					Sketchup.active_model.selection.add face
					@faces << face
				end
			end
		end
	end
	
	def facenil (face)
		a = false
		@faces.each{|e|
			if e == face
				a = true
				break
			end
		}
		return a
	end
	
	def onCancel(reason, view)
		Sketchup.active_model.selection.clear
		@faces = []
		if not @steps.empty?
			@step -= @steps.pop
		end
	end
	
	def onLButtonDown(flags, x, y, view)
		@buttondown = true
		@ip.pick(view,x,y)
		face = @ip.face
		if face!=nil
			if not facenil face
				Sketchup.active_model.selection.add face
				@faces << face
			end
		end
	end
	
	def onLButtonUp(flags, x, y, view)
		@buttondown = false
		if not @faces.empty?
			model = Sketchup.active_model
			model.start_operation '智能梯步拉伸'
			a = 0
			@faces.each{|e|
				a += 1
				@step += 1
				e.pushpull @step * @hight
			}
			@steps << a
			model.commit_operation
			@faces = []
			model.selection.clear
			Sketchup::set_status_text "智能梯步拉伸，按住鼠标启用。梯级 #{@step}, 当前高度 #{@hight.to_m} 米"
		end
	end
	
	def onUserText(text, view)
		begin
			@hight = text.to_l
			Sketchup::set_status_text "递增值: #{@hight} ", SB_VCB_LABEL
		rescue
			puts "Cannot convert #{text} to a Length"
			@hight = nil
			Sketchup::set_status_text "", SB_VCB_VALUE
		end
		return if !@hight		 
	end	
end
  
end # module