=begin rdoc
作者：dota_
版本：1.0
名称：柔滑工具
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Smooth_1 = UI::Command.new('柔化选择') { Smooth.smooth_on }
		cmd_Smooth_1.large_icon = 'Images/Smooth_on_24.png'
		cmd_Smooth_1.small_icon = 'Images/Smooth_on_16.png'
		cmd_Smooth_1.status_bar_text = '柔化所选择的对象。'
		cmd_Smooth_1.tooltip = '柔化选择'
		
		cmd_Smooth_2 = UI::Command.new('取消柔化') { Smooth.smooth_off }
		cmd_Smooth_2.large_icon = 'Images/Smooth_off_24.png'
		cmd_Smooth_2.small_icon = 'Images/Smooth_off_16.png'
		cmd_Smooth_2.status_bar_text = '取消柔化所选择的对象。'
		cmd_Smooth_2.tooltip = '取消柔化'

		# Menu
		@menu.add_separator
		@menu.add_item( cmd_Smooth_1 )
		@menu.add_item( cmd_Smooth_2 )

		# Toolbar
		@toolbar.add_separator
		@toolbar.add_item( cmd_Smooth_1 )
		@toolbar.add_item( cmd_Smooth_2 )
		
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Smooth

		def self.smooth_on
			model = Sketchup.active_model
			sel = model.selection
			edges = []
			sel.each{|e|
				if (e.is_a?(Sketchup::Edge))
					#if e.faces.length > 1
					if not e.smooth?
						edges << e
					end
					#end
				end
			}
			
			if edges.length == 0
				UI.messagebox '未发现可柔化的边线 !'
				return nil
			end
	
			model.start_operation "柔化选择"
			
			edges.each{|e|
				e.smooth = true
				e.soft = true
			}
			
			model.commit_operation
			
		end
		
		def self.smooth_off
			model = Sketchup.active_model
			sel = model.selection
			edges = []
			
			sel.each{|e|
				if (e.is_a?(Sketchup::Edge))
					if e.smooth?
						edges << e
					end
				end
			}
			
			if edges.length == 0
				UI.messagebox '未发现可取消柔化的边线 !'
				return nil
			end
		
			model.start_operation "取消柔化"
			
			edges.each{|e|
				e.smooth = false
				e.soft = false
			}
			
			model.commit_operation
			
		end

	end
  
end # module