=begin rdoc
作者：dota_
版本：1.0
名称：选环面线
=end

module SU::Powertools

	### MENU & TOOLBARS ### --------------------------------------------------

	unless file_loaded?( __FILE__ )      
		cmd_Dota_select_edges = UI::Command.new('选环面线') { Sketchup.active_model.tools.push_tool Dota_select_edges.new }
		cmd_Dota_select_edges.large_icon = 'Images/Select_edges_24.png'
		cmd_Dota_select_edges.small_icon = 'Images/Select_edges_16.png'
		cmd_Dota_select_edges.status_bar_text = '选择环绕于面的一段连续的边线。'
		cmd_Dota_select_edges.tooltip = '选环面线'

		# Menu
		@menu.add_item( cmd_Dota_select_edges )
		#@menu.add_separator

		# Toolbar
		@toolbar.add_item( cmd_Dota_select_edges )
		#@toolbar.add_separator
	end # UI
	file_loaded( __FILE__ )
  
  
	### METHODS ### ----------------------------------------------------------
	class Dota_select_edges
		
		def initialize
			@first_edge = nil
			@second_edge = nil
			@select_case = 1
			Sketchup.status_text = "选环面线：选择属于面的第一根边线。作者：dota_"
		end
		
		def onLButtonUp(flags, x, y, view)
			ip = view.pick_helper
			ip.do_pick(x, y)
			e = ip.best_picked
			sel = Sketchup.active_model.selection
			if e.is_a?( Sketchup::Edge )
				if @first_edge == nil
					sel.add e
					@first_edge = e
				else
					if @first_edge != e
						@second_edge = e
						dota_pick (@select_case)
					end
				end
			end

		end
		
		def dota_pick (s)
			if @first_edge != nil && @second_edge != nil
				Sketchup.active_model.selection.clear
				first_faces = []
				face_ = nil
				@first_edge.faces.each{|e| first_faces << e}
				@second_edge.faces.each{|e|
					first_faces.each{|f|
						if f == e
							face_ = e
							break
						end
					}
					break if face_ != nil
				}
				if face_ == nil
					UI.messagebox '所选择的两根线没有共面，请重新选择 !'
					@first_edge = nil
					@second_edge= nil
					return
				else
					xhjc = 0
					a = 0
					b = 0
					edges = []
					face_.edges.each{|e| edges << e}
					edges.each{|e|
						if e == @first_edge
							a = xhjc 
						elsif e == @second_edge
							b = xhjc 
						end
						xhjc += 1
					}
					if a == nil || b == nil
						UI.messagebox '插件错误，请反馈给作者 !'
						return
					end
					
					if s == 1
						a, b = b, a if a > b
						for i in a..b
							Sketchup.active_model.selection.add edges[i]
						end
					else
						a, b = b, a if a > b
						for i in 0..a
							Sketchup.active_model.selection.add edges[i]
						end
						for i in b..(edges.length - 1)
							Sketchup.active_model.selection.add edges[i]
						end
					end
				end
			end
		end
		
		def onMouseMove(flags, x, y, view)
			if @first_edge == nil
				Sketchup.status_text = "选环面线：选择属于面的第一根边线。作者：dota_"
			elsif @second_edge == nil
				Sketchup.status_text = "选环面线：选择属于面的第二根边线。作者：dota_"
			else
				Sketchup.status_text = "选环面线：按 TAB 键切换选择方向。作者：dota_"
			end
		end
		
		def onKeyUp(key, rpt, flags, view)
			if key==9
				if @select_case == 1
					@select_case = 2
				else
					@select_case = 1
				end
				dota_pick (@select_case)
				view.invalidate
			end
		end
		
	end
  
end # module